//+------------------------------------------------------------------+
//|                                                   _1.mq4 |
//|                                                      ALEX_SPB_RU |
//|                                              lexaforex@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "ALEX_SPB_RU"
#property link      "lexaforex@yandex.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Turquoise
#property indicator_width1 1
#property indicator_color2 Violet
#property indicator_width2 1
#property indicator_color3 Gold
#property indicator_width3 2

// 
extern int vistup=25;   //        ,      
extern bool pokaz_urov_vistupa=true;   //         vistup 
extern bool vivod_tekst_inform=true;   //     

// 
double max[];     //     
double min[];     //     
double por[];     //       ,    vistup
double shagi[];   //             

//,         
int trend;        //            ,  ,     
double lokal_max; //    
double lokal_min; //    
double t_max;     //     
double t_min;     //     
double last_max;  //     
double last_min;  //     
int vsego_up;
int vsego_dn;
double summa_up;
double summa_dn;
double max_up;
double max_dn;
double time_max;
double time_min;
bool kommentariy;


//,      

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,234);
   SetIndexBuffer(0,max);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,233);
   SetIndexBuffer(1,min);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,170);
   SetIndexBuffer(2,por);
   SetIndexEmptyValue(2,0.0);
   SetIndexBuffer(3,shagi);
   SetIndexEmptyValue(3,0.0);
   trend=0;
   lokal_max=-1.0;
   lokal_min=10000000.0;
   vsego_up=0;
   vsego_dn=0;
   summa_up=0;
   summa_dn=0;
   max_up=0;
   max_dn=0;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, n, counted_bars=IndicatorCounted();
   i=Bars-counted_bars-1;
   while(i>=0)
      {
       if(trend==1)              //       
         {
          if(High[i]>=lokal_max)
            {
             lokal_max=High[i];
             t_max=Time[i];
             lokal_min=lokal_max;
             t_min=t_max;
            }
          else if(Low[i]<=lokal_min)
            {
             lokal_min=Low[i];
             t_min=Time[i];
            }
          if(lokal_max-lokal_min>=vistup*Point)
            {
             max[iBarShift(NULL, 0, t_max, true)]=lokal_max;
             if(pokaz_urov_vistupa)
               por[i]=lokal_max-vistup*Point;
             last_max=lokal_max;
             shagi[i]=(last_max-last_min)/Point;
             vsego_up++;
             summa_up=summa_up+shagi[i];
             if(max_up<shagi[i])
               {
                max_up=shagi[i];
                time_max=t_max;
               }
             kommentariy=TRUE;
             n=i;
             //Alert(". =", shagi[i], "  max_up=", max_up, "  time_max=", TimeToStr(time_max), "  vsego_up=", vsego_up, "  summa_up=", summa_up, "   ", summa_up/vsego_up);
             trend=-1;
             lokal_max=lokal_min;
             t_max=t_min;
            }
         }
       else if(trend==-1)        //        
         {
          if(Low[i]<=lokal_min)
            {
             lokal_min=Low[i];
             t_min=Time[i];
             lokal_max=lokal_min;
             t_max=t_min;
            }
          else if(High[i]>=lokal_max)
            {
             lokal_max=High[i];
             t_max=Time[i];
            }
          if(lokal_max-lokal_min>=vistup*Point)
            {
             min[iBarShift(NULL, 0, t_min, true)]=lokal_min;
             if(pokaz_urov_vistupa)
               por[i]=lokal_min+vistup*Point;
             last_min=lokal_min;
             shagi[i]=(last_min-last_max)/Point;
             vsego_dn++;
             summa_dn=summa_dn+shagi[i];
             if(max_dn>shagi[i])
               {
                max_dn=shagi[i];
                time_min=t_min;
               }
             kommentariy=TRUE;
             n=i;
             //Alert(". =", shagi[i], "  max_dn=", max_dn, "  time_min=", TimeToStr(time_min),"  vsego_dn=", vsego_dn, "  summa_dn=", summa_dn, "   ", summa_dn/vsego_dn);
             trend=1;
             lokal_min=lokal_max;
             t_min=t_max;
            }
         }
       else                      //   ,               
         {
          if(High[i]>=lokal_max) //     ,   
            {
             lokal_max=High[i];
             t_max=Time[i];
            }
          if(Low[i]<=lokal_min) //     ,   
            {
             lokal_min=Low[i];
             t_min=Time[i];
            }
          if(lokal_max-lokal_min>=vistup*Point) //        , ...
            {
             if(t_max>t_min)
               {
                min[iBarShift(NULL, 0, t_min, true)]=lokal_min;
                if(pokaz_urov_vistupa)
                  por[i]=lokal_min+vistup*Point;
                last_min=lokal_min;
                trend=1;
                lokal_min=lokal_max;
                t_min=t_max;
               }
             if(t_max<t_min)
               {
                max[iBarShift(NULL, 0, t_max, true)]=lokal_max;
                if(pokaz_urov_vistupa) 
                  por[i]=lokal_max-vistup*Point;
                last_max=lokal_max;
                trend=-1;
                lokal_max=lokal_min;
                t_max=t_min;
               }
            }
         }
       i--;
      }
   if(vivod_tekst_inform && kommentariy)
      {
       Comment("  = ", shagi[n], "   UP:  = ", max_up, ",     :  ", TimeToStr(time_max), ",     = ", summa_up/vsego_up,
               "\n                                   DN:  = ", max_dn, ",     :  ", TimeToStr(time_min), ",     = ", summa_dn/vsego_dn);
       kommentariy=FALSE;
      }
   return(0);
  }
//+------------------------------------------------------------------+

